;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================

ORG 5014

@DFile=400C
@X1Y1=4036

;================================
;Plot Routine, full screen Plot/UNPlot statements.
;Modified from...
;
;Um Plot Rpido (RAPID Plot)
;"Usando Linguagem De Mquina" 
;by Mario Schaeffer
;
;B=Ycoord, 0 to 47
;C=Xcoord, 0 to 63
;Pixel 0-NW	A=87
;Pixel 1-NE	A=8F
;Pixel 2-SW	A=97
;Pixel 3-SE	A=9F
;================================
;Test for XY coordinates in range
;================================
@TestXY
	LD BC,(X1Y1)		;BC=XY coordS
@TestX
	LD A,3F			;X>63?
	SUB C 
	JR NC TestY
@ErrorH
	RST 08			;Yes, Error Code:'H'
	10			;X>63
@TestY
	LD A,2F			;Y>47?
	SUB B 
	RET NC
@ErrorV
	RST 08			;Yes, Error Code:'V'
	1E			;Y>43
;================================
@Plot
	CALL TestXY
	LD A,40
	JR Plot01
@UNPlot
	CALL TestXY
	XOR A
@Plot01				;Is Y an ODD or EVEN row?
	PUSH AF			;SAVE Plot/UNPlot value.
	LD A,87			;A=87=NW Pixel
	BIT 0,B			;Y
	JR NZ Plot02		;ODD line number?
				;No, must be an EVEN line number 
	ADD A,10			;A=97=SW Pixel 
@Plot02				;Is X ODD or EVEN column?		
	BIT 0,C			;X
	JR Z Plot03		;EVEN col number?
				;No, must be an ODD row number 
	ADD A,08		;A=8F=NE Pixel or A=9F=SE Pixel
@Plot03
	LD D,A			;D=Pixel quadrant value
	POP AF
	ADD A,D			;A=D IF UNPlot or D+64 IF Plot
	LD (PlotPX+1),A		;Self modifying code
	SRL B			;Convert Y-coord to Print coord, Y/2
	SRL C			;Convert X-coord to Print coord, X/2
	LD HL,(DFile)
	INC HL
	LD D,00
	LD E,C			;DE=Column number
	ADD HL,DE		;HL=Column position in DFile
	LD A,17			;23-Y/2
	SUB B
	LD B,A			;B=Row number
	JR Z Plot05
	LD DE,21
@Plot04
	ADD HL,DE
	DJNZ Plot04
@Plot05
	LD A,(HL)
	CP 08			;LO Pixel Chr
	JR C PlotPX
	CPL			;HI Pixel Chr
@PlotPX
	SET 00,A		;00=SR SET/RES X,A
	BIT 3,A
	JR Z LowPX
	CPL
	AND 8F
	JR HiPX
@LowPX				;Low value PIXEL, codes 1 to 7
	AND 0F
@HiPX				;Hi value PIXEL, codes 128 to 135
	LD (HL),A
	RET 
